**==wrden.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      SUBROUTINE WRDEN(E,EZERO,BETA,AVENU,NSVIB,NROT,DENS,WRSUM)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C	Calculates sums and densities of vib/rot states, based on
C		Whitten-Rabinovitch approximation
C
C	Uses FUNCTION ALNGAM(X), which calculates natural logarithm
C		of the gamma FUNCTION of x
C
C	E	= energy (cm-1)
C	EZERO	= zero point energy (cm-1)
C	BETA	= W-R beta parameter
C	AVENU	= geometric mean frequency (cm-1)
C	NSVIB	= number of vibs
C	NROT	= number of rots
C	DENS	= density of states (states/cm-1)
C	WRSUM	= sum of states
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE 
      EXTERNAL ALNGAM
      SVIB = DBLE(NSVIB)
      SROT = DBLE(NROT)
      GMF = ALNGAM(SVIB+.5*SROT)
      WRE = E/EZERO
      ALHNUP = SVIB*LOG(AVENU)
      IF ( WRE.GT.0.0 ) THEN
         IF ( WRE.LT.1.0 ) THEN
            W = 1.0/((5.0*WRE)+2.73*(SQRT(WRE))+3.51)
            DW = -W*W*(5.0+1.365/(SQRT(WRE)))
         ELSE
            W14 = SQRT(SQRT(WRE))
            W = EXP(-2.4191*(W14))
            W34 = W14**3
            DW = -W*0.60478/W34
         ENDIF
         A = 1.0 - (BETA*W)
         BRAC = LOG(1.0-(BETA*DW))
         ALNDEN = (SVIB+.5*SROT-1.0)*(LOG(E+A*EZERO)) + BRAC - GMF - 
     &            ALHNUP
         WRSUM = (SVIB+.5*SROT)*LOG(E+A*EZERO) - GMF - ALHNUP - 
     &           LOG(SVIB+.5*SROT)
      ELSE
         AWR = 1.0 - BETA/3.51
         ALNDEN = (SVIB+.5*SROT-1)*LOG(AWR*EZERO) - ALHNUP - GMF
         WRSUM = -LOG(SVIB+.5*SROT) + (SVIB+.5*SROT)*LOG(AWR*EZERO)
     &           - ALHNUP - GMF
      ENDIF
      WRSUM = EXP(WRSUM)
      DENS = EXP(ALNDEN)
      RETURN
      END
